# -*- coding: utf-8 -*-
"""
Created on Wed Sep  8 20:49:59 2021

@author: a
"""

# -*- coding: utf-8 -*-
"""
Created on Sun Sep  5 16:29:39 2021

@author: a
"""

import torch
import torch.utils.data as Data
import numpy as np
from model1 import LSTM_AE
#from model2 import LSTMAE
from sklearn import cluster, metrics

#device = torch.device("cuda" if torch.cuda.is_available() else "cpu")

class phone_data(Data.Dataset):
    def __init__(self,path, normalization = 'Two'):
        self.normalization = normalization
        self.phone = self.load(path)
    
    def __getitem__(self, index):
        return self.phone[index]
    
    def load(self,path):
        train_data01 = []
        train_data02 = []
        with open(path,'r+') as f:
            for line in f:
                pData = line.strip().split(",")
                pData = np.reshape(pData, (1, 168)).astype(float)
                p_max = np.max(pData)
                train_data01.append(pData/(p_max+10e-7))
                train_data02.append(pData)
        train_data01 = np.array(train_data01)
        train_data02 = np.array(train_data02)
        zmax_train02 = train_data02.max(axis = 0)
        train_data02 = train_data02/(zmax_train02+10e-7)
        train_data = np.concatenate((train_data01, train_data02), axis = -1)
        return train_data
    
    def __len__(self):
        return len(self.phone)

if __name__ == '__main__':
    # Hyper Parameters
    BATCH_SIZE = 16
    LATENT_CODE_NUM = 7
    k = 10    # the expected speed of convergence
    model_path = './trained model/model_ep100_hidden7.pth'
    
    data = phone_data(r'./data/su_jz for cluster2.csv')
    train_loader1 = Data.DataLoader(dataset    = data,
                                   batch_size = 1,
                                   shuffle    = False)
     
    model = LSTM_AE(inp_dim   = 2,
                    out_dim   = 2, 
                    hid_dim   = 48,
                    code_size = LATENT_CODE_NUM,
                    bsz       = BATCH_SIZE,
                    tf_p      = 1,    # Teacher forcing with Scheduled Sampling
                    n_layers  = 1)
    model.load_state_dict(torch.load(model_path))
    
    #  encode
    model.eval()
    encoded_data = []
    decoded_data = []
    for seq in train_loader1:
        seq = seq.float()
        seq = seq.repeat(BATCH_SIZE, 1, 1)
        encode, decode = model(seq)
        encoded_data.append(encode[0,:].contiguous().view((-1)).detach().numpy())
        decoded_data.append(decode[0,:].contiguous().view((-1)).detach().numpy())
    encoded_data = np.array(encoded_data)
    decoded_data = np.array(decoded_data)
    print(encoded_data.shape)
    
    # kmeans
    nclusters = 6
    kmeans = cluster.KMeans(n_clusters = nclusters)
    kmeans.fit(encoded_data)
    y_cls = kmeans.labels_
    y_centers = kmeans.cluster_centers_
    np.savetxt('1_cls.csv', y_cls,  fmt="%s", delimiter = ',')
    np.savetxt('1_center.csv', y_centers,  fmt="%s", delimiter = ',')
    
    score = metrics.calinski_harabaz_score(encoded_data, y_cls)
    score1 = metrics.silhouette_score(encoded_data, y_cls)
    print("method1 clusters value is %f\t%f\n" % (score, score1))
    
    # kmeans with diffence n_clusters
    for n in range(2,20):
        kmeans = cluster.KMeans(n_clusters = n)
        kmeans.fit(encoded_data)
        score = metrics.calinski_harabaz_score(encoded_data,kmeans.labels_)
        score1 = metrics.silhouette_score(encoded_data,kmeans.labels_)
        print("%d clusters kmeans value is %f\t%f" % (n, score, score1))